ghc-7.6.3: The GHC API

Safe Haskell | None

SimplUtils

# Documentation

mkLam :: SimplEnv -> [OutBndr] -> OutExpr -> SimplM OutExpr

mkCase :: DynFlags -> OutExpr -> OutId -> OutType -> [OutAlt] -> SimplM OutExpr

prepareAlts :: OutExpr -> OutId -> [InAlt] -> SimplM ([AltCon], [InAlt])

tryEtaExpand :: SimplEnv -> OutId -> OutExpr -> SimplM (Arity, OutExpr)

preInlineUnconditionally :: SimplEnv -> TopLevelFlag -> InId -> InExpr -> Bool

postInlineUnconditionally :: SimplEnv -> TopLevelFlag -> OutId -> OccInfo -> OutExpr -> Unfolding -> Bool

activeUnfolding :: SimplEnv -> Id -> Bool

activeRule :: SimplEnv -> Activation -> Bool

getUnfoldingInRuleMatch :: SimplEnv -> IdUnfoldingFun

simplEnvForGHCi :: DynFlags -> SimplEnv

updModeForInlineRules :: Activation -> SimplifierMode -> SimplifierMode

data SimplCont

Constructors

Stop OutType CallCtxt |
CoerceIt OutCoercion SimplCont |
ApplyTo DupFlag InExpr StaticEnv SimplCont |
Select DupFlag InId [InAlt] StaticEnv SimplCont |
StrictBind InId [InBndr] InExpr StaticEnv SimplCont |
StrictArg ArgInfo CallCtxt SimplCont |
TickIt (Tickish Id) SimplCont |

Instances

Outputable SimplCont |

data DupFlag

Constructors

NoDup |
Simplified |
OkToDup |

Instances

Outputable DupFlag |

data ArgInfo

Constructors

ArgInfo |
Fields ai_fun :: OutId ai_args :: [OutExpr] ai_type :: OutType ai_rules :: [CoreRule] ai_encl :: Bool ai_strs :: [Bool] ai_discs :: [Int]

isSimplified :: DupFlag -> Bool

contIsDupable :: SimplCont -> Bool

contResultType :: SimplCont -> OutType

contInputType :: SimplCont -> OutType

contIsTrivial :: SimplCont -> Bool

contArgs :: SimplCont -> (Bool, [ArgSummary], SimplCont)

dropArgs :: Int -> SimplCont -> SimplCont

pushSimplifiedArgs :: SimplEnv -> [CoreExpr] -> SimplCont -> SimplCont

countValArgs :: SimplCont -> Int

countArgs :: SimplCont -> Int

addArgTo :: ArgInfo -> OutExpr -> ArgInfo

mkBoringStop :: OutType -> SimplCont

mkRhsStop :: OutType -> SimplCont

mkLazyArgStop :: OutType -> CallCtxt -> SimplCont

contIsRhsOrArg :: SimplCont -> Bool

interestingCallContext :: SimplCont -> CallCtxt

interestingArg :: CoreExpr -> ArgSummary

mkArgInfo :: Id -> [CoreRule] -> Int -> SimplCont -> ArgInfo

abstractFloats :: [OutTyVar] -> SimplEnv -> OutExpr -> SimplM ([OutBind], OutExpr)